import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.BorderLayout;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.Canvas;
import java.awt.Color;
import javax.swing.JOptionPane;
import java.awt.MenuBar;
import java.awt.Menu;
import java.awt.MenuItem;


public class FinestraNapoleon extends JFrame
                   implements MouseListener, ActionListener
{
	// instance variables
    private Napoleon napo;
    // source and target of the mouse events
    private Object source;
    private Object target;
  

    public FinestraNapoleon()
	{
   		napo = new Napoleon(); 
		napo.mescolaEDaiCarte();
	    generaFinestra();
	}
	
	
	
	public void generaFinestra()
	{    
    	setTitle("jNAPOLEON by Vessillo");
    	setSize(800,600);
		Container sfondo = getContentPane();
		JPanel pannello = new JPanel();
		pannello.setLayout(new BorderLayout());
		sfondo.add(pannello);
		JPanel east = new JPanel();
		JPanel center = new JPanel();
		JPanel west = new JPanel();
		
		pannello.add(east, BorderLayout.EAST);
		pannello.add(center, BorderLayout.CENTER);
		pannello.add(west, BorderLayout.WEST);
		
		east.setLayout(new GridLayout(4,1));
		center.setLayout(new GridLayout(4,1));
		west.setLayout(new GridLayout(4,1));
		
		west.add(napo.leggiLista(0));
		east.add(napo.leggiLista(1));
		west.add(napo.leggiLista(2));
		east.add(napo.leggiLista(3));
		west.add(napo.leggiLista(4));
		east.add(napo.leggiLista(5));
		west.add(napo.leggiLista(6));
		east.add(napo.leggiLista(7));
		
		center.add(napo.leggiPila(0));
		center.add(napo.leggiPila(1));
		center.add(napo.leggiPila(2));
		center.add(napo.leggiPila(3));
			
	    // building menu
	    MenuBar menuBar = new MenuBar();
	    Menu menuGioco = new Menu(" Game ");
	    Menu menuHelp = new Menu(" ? ");
	    MenuItem menuNuovaPartita = new MenuItem(" New Game ");
	    MenuItem menuUndo = new MenuItem(" Undo Last Move ");
	    MenuItem menuStatistica = new MenuItem(" Statistics ");
	    MenuItem menuEsci = new MenuItem(" Exit ");
	    MenuItem menuIstruzioni = new MenuItem(" Game Instructions ");
	    MenuItem menuVersione = new MenuItem(" About ");
	    setMenuBar(menuBar);
	    menuBar.add(menuGioco);
	    menuBar.add(menuHelp);
	    menuGioco.add(menuNuovaPartita);
	    menuGioco.addSeparator();
	    menuGioco.add(menuUndo);
	    menuGioco.addSeparator();
	    menuGioco.add(menuStatistica);
	    menuGioco.addSeparator();
	    menuGioco.add(menuEsci);
	    menuHelp.add(menuIstruzioni);
	    menuHelp.addSeparator();
	    menuHelp.add(menuVersione);
	    menuNuovaPartita.addActionListener(this);
	    menuUndo.addActionListener(this);
	    menuStatistica.addActionListener(this);
	    menuEsci.addActionListener(this);
	    menuIstruzioni.addActionListener(this);
	    menuVersione.addActionListener(this);
	    			
		for(int i=0; i<4; i++)
		{
		    napo.leggiPila(i).addMouseListener(this);
        }
        for(int i=0; i<8; i++)
		{
		    napo.leggiLista(i).addMouseListener(this);
        }        
		setVisible(true);
	}

    public void aggiornaFinestra()
    {
        for(int i = 0; i < 4; i++)
        {
            napo.leggiPila(i).repaint();
        }
        for(int i = 0; i < 8; i++)
        {
            napo.leggiLista(i).repaint();
        }

    }


   // menu actions
   public void  actionPerformed(ActionEvent e)
   {
       String comando = e.getActionCommand();
       if (comando.equals(" New Game "))
       { nuovaPartita(); }
       else if (comando.equals(" Undo Last Move "))
       { 
           boolean ok = napo.undoSpostamento(); 
           if (ok)
           { 
               aggiornaFinestra();
            }
           else
           { JOptionPane.showMessageDialog(this, "There is no move to undo!");}
        }
       else if (comando.equals(" Statistics "))
       { JOptionPane.showMessageDialog(this, napo.leggiStatistica());}
       else if (comando.equals(" Exit "))
       { System.exit(0); }
       else if (comando.equals(" Game Instructions "))
       {
           String testo =  "------------------------ jNapoleon ------------------------------- \n";
           testo = testo + " Solitaire Card Game based upon strategy and calculation \n\n";
           testo = testo + " Objective: put the cards onto the 4 central stacks      \n";
           testo = testo + "    one for each suit, beginning from the Ace            \n";
           testo = testo + " You may take each card from the top of the 8 lateral    \n";
           testo = testo + "    decks.                                               \n";
           testo = testo + " Then , each card may be placed directly onto its stack  \n";
           testo = testo + "    or onto the top of another deck, if possible.        \n";
           testo = testo + " A move is performed making a CLICK on the source deck   \n";
           testo = testo + "    and a CLICK on the destination site (a stack or a    \n";
           testo = testo + "    deck).                                               \n";
           testo = testo + " Take good care before making a move because only the    \n";
           testo = testo + "    last one is reversible!                              \n";           
           testo = testo + "------------------------------------------------------------------ \n";
           testo = testo + " Hint: Try first to empty a deck so you will have more   \n";
           testo = testo + "    possibility to move cards from the other decks!      \n";
           testo = testo + "------------------------------------------------------------------ \n";
           testo = testo + " Note: Not all the games will end positively!            \n";
           testo = testo + "------------------------------------------------------------------ \n";
           testo = testo + "                  !!! HAVE FUN !!!                       \n";
           JOptionPane.showMessageDialog(this, testo);
           
       }
       else if (comando.equals(" About "))
       { JOptionPane.showMessageDialog(this, " jNapoleon - version 1.1 - november 2005        \n\n" +
                                             " Author: Roberto Bandiera <vessillo@tiscali.it> \n" + 
                                             " If you like this game please send me a mail!   \n"
                                       ); 
       }              
   }

 
   // gestione eventi  del mouse
   public void 	mouseClicked(MouseEvent e) 
   { 
        if (source == null) 
        { 
            source = e.getSource();
            Lista a = (Lista) source;
            if  (!a.pila())
            {
               Canvas c = (Canvas) source;
               c.setBackground(Color.yellow);
               c.repaint();
            }
            else
            {
                source = null;
            }
        }
        else
        {
            target = e.getSource(); 
            if (source != target)
            {               
               Lista a = (Lista) source;
               Lista b = (Lista) target;
               boolean ok = napo.sposta(a, b); 
               a.setBackground(Color.green);
               a.repaint();
               if (ok)
               {
                  b.repaint();  
               }
               source = null;
               // check if you have win
               if (b.pila())
               {
                   if (napo.haiVinto())
                   {
                           JOptionPane.showMessageDialog(this, "MANY COMPLIMENTS, YOU WIN!\n" + 
                                           napo.leggiStatistica());
                   }  
               }
            }  
            else // source == target
            {
                   Canvas c = (Canvas) source;
                   c.setBackground(Color.green);
                   c.repaint();
                   source = null;
            }                      
        }
   }
   
   
   public void 	mouseEntered(MouseEvent e) {}
   public void  mouseExited(MouseEvent e) {}
   public void 	mousePressed(MouseEvent e) {}    
   public void 	mouseReleased(MouseEvent e){} 
   

    public  void nuovaPartita()
    {
               napo.preparaNuovaPartita();
               napo.mescolaEDaiCarte();
               aggiornaFinestra();               
      }
   
 
   public static void main(String[] args)
   {
       FinestraNapoleon f = new FinestraNapoleon(); 
   }

}


