import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Color;
import java.awt.Image;


public class Lista extends Canvas
{
	// instance variables 
	private Carta[] carta;
	private int numeroCarte;
	private int maxNumeroCarte;
	private boolean pila;
	private int hSize;
	private int vSize;
	

	public Lista(int massimoNumeroCarte, boolean inPila)
	{
		maxNumeroCarte = massimoNumeroCarte;
		carta = new Carta[maxNumeroCarte];   // max 20 cards
		numeroCarte = 0;
		pila = inPila;  // true if stack, false if side by side
		
		// to paint the Canvas
		if (pila)
		   { hSize = 100; }
		else 
    	   { hSize = 300; }
		vSize = 100;
		setSize(hSize, vSize);
		setBackground(Color.green);		
	}
	
	public boolean pila()
	{ return pila; }
	
	
	// empty the list 
	public void svuota()
	{
	   carta = new Carta[maxNumeroCarte];
	   numeroCarte = 0;
    }
	
	
	public int leggiNumeroCarte()
	{ return numeroCarte; }


    public Carta leggiCarta(int posizione)
    {  return carta[posizione]; }


    public Carta leggiTop()
    {  return carta[numeroCarte - 1]; }
    
    public void aggiungi(Carta unaCarta) // at the end of the list
    {
        carta[numeroCarte] = unaCarta;
        numeroCarte++;
    } 

    public void togliCarta()  // removes the last card from the list
    {
        carta[numeroCarte - 1] = null;
        numeroCarte--;
    }


    public void paint(Graphics g)
    {
       if (numeroCarte > 0)
       {
           if (pila)
           {
               Image img =  leggiTop().leggiIcona().getImage();
               g.drawImage(img, 10, 10, null);
            }
            else
            {
                for(int i=0; i<numeroCarte; i++)
                {
                   Image img =  leggiCarta(i).leggiIcona().getImage();
                   g.drawImage(img, i*15 + 10, 10, null);
                }   
            }
        }    
        else
        {
              g.drawRect(10, 10, 68, 96);
        }  
    }


}


